#define _GNU_SOURCE

#include <errno.h>
#include <signal.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <unistd.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <sys/poll.h>
#include <arpa/inet.h>


void dump (struct addrinfo *ai)
{
	printf ("flags=%08x family=%d socktype=%d protocol=%d addrlen=%d canonname=[%s]\n",
		ai->ai_flags, ai->ai_family, ai->ai_socktype, ai->ai_protocol, ai->ai_addrlen, ai->ai_canonname);
}

int main (void)
{
	struct sockaddr		*sa;
	struct hostent		*hp;
	char			*myservice = "9110";
	struct addrinfo		hints;
	struct addrinfo		*res;
	int			error, salen;

	/*
	 * getaddrinfo() case.  You can get IPv6 address and IPv4 address
	 * at the same time.
	 */
	memset(&hints, 0, sizeof(hints));
	/* set-up hints structure */
	hints.ai_family = PF_UNSPEC;
	hints.ai_flags |= AI_PASSIVE;
	hints.ai_socktype = SOCK_STREAM;
	error = getaddrinfo(NULL, myservice, &hints, &res);
	if (error)
		perror(gai_strerror(error));
	else {
		while (res) {
			dump(res);
			res = res->ai_next;
		}
	}

	return 0;
}
